/*
 * The SmartWeb Framework
 * Copyright (C) 2004-2006
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
 *
 * For further informations on the SmartWeb Framework please visit
 *
 *                        http://smartweb.sourceforge.net
 */
package net.smartlab.web.test;

import net.smartlab.config.Configuration;
import net.smartlab.config.ConfigurationException;
import net.smartlab.config.XMLConfiguration;
import net.smartlab.web.BusinessObjectFactory;
import net.smartlab.web.Domain;
import net.smartlab.web.config.DomainConfigurationStrategy;
import net.smartlab.web.test.ModelTestCase.TestConfiguration;

/**
 * TODO documentation
 * 
 * @author rlogiacco
 */
public abstract class DomainTestCase extends ModelTestCase {

	/**
	 * Default constructor.
	 */
	public DomainTestCase() {
		super();
	}

	/**
	 * Named constructor.
	 * 
	 * @param name test name.
	 */
	public DomainTestCase(String name) {
		super(name);
	}
	
	/**
     * @see junit.framework.TestCase#setUp()
     */
    protected void setUp() throws Exception {
        if (logger.isDebugEnabled()) {
            logger.debug("setUp() - start");
        }
        Domain.setConfigurationStrategy(new TestConfigurationStrategy());
        super.setUp();
    }


	/**
	 * @TODO documentation
	 * @author rlogiacco@smartlab.net
	 */
	protected class TestConfigurationStrategy implements DomainConfigurationStrategy {

		/**
		 * @throws ConfigurationException
		 * @see net.smartlab.web.config.ConfigurationStrategy#getConfiguration()
		 */
		public Configuration getConfiguration(Domain domain) throws ConfigurationException {
			return new XMLConfiguration("res/smartweb.jar.xml");
		}

		/**
		 * @see net.smartlab.web.config.ConfigurationStrategy#getConfiguration(java.lang.String)
		 */
		public Configuration getConfiguration(Domain domain, String filename) throws ConfigurationException {
			return new XMLConfiguration("res/" + filename);
		}
	}
}
